silk/urls.py
from django.urls import path

from silk.views.clear_db import ClearDBView
from silk.views.cprofile import CProfileView
from silk.views.profile_detail import ProfilingDetailView
from silk.views.profile_dot import ProfileDotView
from silk.views.profile_download import ProfileDownloadView
from silk.views.profiling import ProfilingView
from silk.views.raw import Raw
from silk.views.request_detail import RequestView
from silk.views.requests import RequestsView
from silk.views.sql import SQLView
from silk.views.sql_detail import SQLDetailView
from silk.views.summary import SummaryView

app_name = 'silk'
urlpatterns = [
    path(route='', view=SummaryView.as_view(), name='summary'),
    path(route='requests/', view=RequestsView.as_view(), name='requests'),
    path(
        route='request/<uuid:request_id>/',
        view=RequestView.as_view(),
        name='request_detail',
    ),
    path(
        route='request/<uuid:request_id>/sql/',
        view=SQLView.as_view(),
        name='request_sql',
    ),
    path(
        route='request/<uuid:request_id>/sql/<int:sql_id>/',
        view=SQLDetailView.as_view(),
        name='request_sql_detail',
    ),
    path(
        route='request/<uuid:request_id>/raw/',
        view=Raw.as_view(),
        name='raw',
    ),
    path(
        route='request/<uuid:request_id>/pyprofile/',
        view=ProfileDownloadView.as_view(),
        name='request_profile_download',
    ),
    path(
        route='request/<uuid:request_id>/json/',
        view=ProfileDotView.as_view(),
        name='request_profile_dot',
    ),
    path(
        route='request/<uuid:request_id>/profiling/',
        view=ProfilingView.as_view(),
        name='request_profiling',
    ),
    path(
        route='request/<uuid:request_id>/profile/<int:profile_id>/',
        view=ProfilingDetailView.as_view(),
        name='request_profile_detail',
    ),
    path(
        route='request/<uuid:request_id>/profile/<int:profile_id>/sql/',
        view=SQLView.as_view(),
        name='request_and_profile_sql',
    ),
    path(
        route='request/<uuid:request_id>/profile/<int:profile_id>/sql/<int:sql_id>/',
        view=SQLDetailView.as_view(),
        name='request_and_profile_sql_detail',
    ),
    path(
        route='profile/<int:profile_id>/',
        view=ProfilingDetailView.as_view(),
        name='profile_detail',
    ),
    path(
        route='profile/<int:profile_id>/sql/',
        view=SQLView.as_view(),
        name='profile_sql',
    ),
    path(
        route='profile/<int:profile_id>/sql/<int:sql_id>/',
        view=SQLDetailView.as_view(),
        name='profile_sql_detail',
    ),
    path(route='profiling/', view=ProfilingView.as_view(), name='profiling'),
    path(route='cleardb/', view=ClearDBView.as_view(), name='cleardb'),
    path(
        route='request/<uuid:request_id>/cprofile/',
        view=CProfileView.as_view(),
        name='cprofile',
    ),
]

silk/views/code.py
from silk.config import SilkyConfig

__author__ = 'mtford'


def _code(file_path, line_num, end_line_num=None):
    line_num = int(line_num)
    if not end_line_num:
        end_line_num = line_num
    end_line_num = int(end_line_num)
    actual_line = []
    lines = ''
    with open(file_path, encoding='utf-8') as f:
        r = range(max(0, line_num - 10), line_num + 10)
        for i, line in enumerate(f):
            if i in r:
                lines += line
            if i + 1 in range(line_num, end_line_num + 1):
                actual_line.append(line)
    code = lines.split('\n')
    return actual_line, code


def _code_context(file_path, line_num, end_line_num=None, prefix=''):
    actual_line, code = _code(file_path, line_num, end_line_num)
    return {
        prefix + 'code': code,
        prefix + 'file_path': file_path,
        prefix + 'line_num': line_num,
        prefix + 'actual_line': actual_line
    }


def _code_context_from_request(request, end_line_num=None, prefix=''):
    file_path = request.GET.get('file_path')
    line_num = request.GET.get('line_num')
    result = {}
    if file_path is not None and line_num is not None:
        result = _code_context(file_path, line_num, end_line_num, prefix)
    return result


def _should_display_file_name(file_name):
    for ignored_file in SilkyConfig().SILKY_IGNORE_FILES:
        if ignored_file in file_name:
            return False
    return True

silk/templates/silk/inclusion/code.html
<pre><code>...
{% for line in code %}<span class="line {% if line.strip in actual_line %}the-line{% endif %}">{{ line }}</span><br>{% endfor %}...</code></pre>

silk/templates/silk/inclusion/heading.html
<div class="heading">
    <div class="inner-heading">
        {{ text }}
    </div>
</div>

silk/templates/silk/inclusion/profile_menu.html
{% load silk_nav %}
<a href="
    {% if silk_request %}
        {% url "silk:request_profiling" silk_request.id %}
    {% else %}
        {% url "silk:profiling" %}
    {% endif %}
">
    <div class="menu-item selectable-menu-item">
        <div class="menu-item-outer">
            <div class="menu-item-inner">&larr;</div>
        </div>
    </div>
</a>
<div class="menu-item selectable-menu-item
            {% if silk_request %}
                {% navactive request 'silk:request_profile_detail' silk_request.id profile.id %}
            {% else %}
                {% navactive request 'silk:profile_detail' profile.id %}
            {% endif %}">
    <a href="
        {% if silk_request %}
            {% url "silk:request_profile_detail" silk_request.id profile.id %}
        {% else %}
            {% url "silk:profile_detail" profile.id %}
        {% endif %}
    ">
        <div class="menu-item-outer ">
            <div class="menu-item-inner">Detail</div>
        </div>
    </a>
</div>
<div class="menu-item selectable-menu-item
            {% if silk_request %}
                 {% navactive request 'silk:request_and_profile_sql' silk_request.id profile.id %}
            {% else %}
                {% navactive request 'silk:profile_sql' profile.id %}
            {% endif %}">
    <a href="
        {% if silk_request %}
            {% url "silk:request_and_profile_sql" silk_request.id profile.id %}
        {% else %}
            {% url "silk:profile_sql" profile.id %}
        {% endif %}
    ">
        <div class="menu-item-outer
        ">
            <div class="menu-item-inner">Queries</div>
        </div>
    </a>
</div>

silk/templates/silk/inclusion/profile_summary.html
{% load silk_filters %}
<div class="cell">
    <div class="timestamp-div">{{ profile.start_time | silk_date_time }}</div>
    <div class="name-div">{% if profile.name %}{{ profile.name }}{% elif profile.func_name %}{{ profile.func_name }}{% endif %}</div>
    <div class="path-div">{{ profile.path }}</div>
    <div class="time-taken-div">
        <span class="numeric">{{ profile.time_taken|floatformat:"0" }}<span class="unit">ms</span></span>
        <span class="appendage">overall</span>
    </div>
    <div class="time-taken-queries-div">
        <span class="numeric">{{ profile.time_spent_on_sql_queries|floatformat:"0" }}<span class="unit">ms</span></span>
        <span class="appenage">on queries</span></div>
    <div class="num-queries-div">
        <span class="numeric">{{ profile.queries.count }}</span>
        <span class="appendage">queries</span>
    </div>
</div>

silk/templates/silk/inclusion/request_menu.html
{% load silk_nav %}
<a href="

    {% url "silk:requests" %}
">
    <div class="menu-item selectable-menu-item">
        <div class="menu-item-outer">
            <div class="menu-item-inner">&larr;</div>
        </div>
    </div>
</a>
<a href="{% url "silk:request_detail" silk_request.id %}">
    <div class="menu-item {% navactive request 'silk:request_detail' silk_request.id %} selectable-menu-item">
        <div class="menu-item-outer">
            <div class="menu-item-inner">Details</div>
        </div>
    </div>
</a>
<a href="{% url "silk:request_sql" silk_request.id %}">
    <div class="menu-item {% navactive request 'silk:request_sql' silk_request.id %} selectable-menu-item">
        <div class="menu-item-outer">
            <div class="menu-item-inner">SQL</div>
        </div>
    </div>
</a>
<a href="{% url "silk:request_profiling" silk_request.id %}">
    <div class="menu-item {% navactive request 'silk:request_profiling' silk_request.id %} selectable-menu-item">
        <div class="menu-item-outer">
            <div class="menu-item-inner">Profiling</div>
        </div>
    </div>
</a>

<a href="{% url "silk:cprofile" silk_request.id %}">
    <div class="menu-item {% navactive request 'silk:cprofile' silk_request.id %} selectable-menu-item">
        <div class="menu-item-outer">
            <div class="menu-item-inner">CProfile</div>
        </div>
    </div>
</a>

silk/templates/silk/inclusion/request_summary.html
{% load silk_filters %}
<div class="cell">
    <div class="timestamp-div">{{ silk_request.start_time | silk_date_time }}</div>
    <div class="method-div">{% if silk_request.response.status_code %}{{ silk_request.response.status_code }} {% endif %}{{ silk_request.method }}</div>
    <div class="path-div">{{ silk_request.path }}</div>
    <div class="time-taken-div">
        <span class="numeric">{{ silk_request.time_taken|floatformat:"0" }}<span class="unit">ms</span></span>
        <span class="appendage">overall<span class="meta">{% if silk_request.total_meta_time %} +{{ silk_request.total_meta_time | floatformat:"0" }}<span class="unit">ms</span>{% endif %}</span></span>
    </div>
    <div class="time-taken-queries-div">
        <span class="numeric">{{ silk_request.time_spent_on_sql_queries|floatformat:"0" }}<span class="unit">ms</span></span>
        <span class="appenage">on queries<span class="meta">{% if silk_request.meta_time_spent_queries %} +{{ silk_request.meta_time_spent_queries | floatformat:"0" }}<span class="unit">ms</span>{% endif %}</span></div>
    <div class="num-queries-div">
        <span class="numeric">{{ silk_request.num_sql_queries }}</span>
        <span class="appendage">queries<span class="meta">{% if silk_request.meta_num_queries %} +{{ silk_request.meta_num_queries  }}{% endif %}</span>
    </div>
</div>

silk/templates/silk/inclusion/request_summary_row.html
{% load silk_filters %}
    <div class="col timestamp-div">{{ silk_request.start_time | silk_date_time }}</div>
    <div class="col method-div">{% if silk_request.response.status_code %}{{ silk_request.response.status_code }} {% endif %}{{ silk_request.method }}</div>
    <div class="col path-div">{{ silk_request.path }}</div>
    <div class="col time-taken-div spacing">
        <span class="numeric">{{ silk_request.time_taken|floatformat:"0" }}<span class="unit">ms</span></span>
        <span class="appendage">overall<span class="meta">{% if silk_request.total_meta_time %} +{{ silk_request.total_meta_time | floatformat:"0" }}<span class="unit">ms</span>{% endif %}</span></span>
    </div>
    <div class="col time-taken-queries-div spacing">
        <span class="col numeric">{{ silk_request.time_spent_on_sql_queries|floatformat:"0" }}<span class="unit">ms</span></span>
        <span class="col appenage">on queries<span class="meta">{% if silk_request.meta_time_spent_queries %} +{{ silk_request.meta_time_spent_queries | floatformat:"0" }}<span class="unit">ms</span>{% endif %}</span></div>
    <div class="col num-queries-div spacing">
        <span class="col numeric">{{ silk_request.num_sql_queries }}</span>
        <span class="col appendage">queries<span class="meta">{% if silk_request.meta_num_queries %} +{{ silk_request.meta_num_queries  }}{% endif %}</span></span>
    </div>

silk/templates/silk/inclusion/root_menu.html
{% load silk_nav %}
<div class="menu-item selectable-menu-item {% navactive request 'silk:summary' %}">
    <a href="{% url "silk:summary" %}">
        <div class="menu-item-outer">
            <div class="menu-item-inner">Summary</div>
        </div>
    </a>
</div>
<div class="menu-item selectable-menu-item {% navactive request 'silk:requests' %}">
    <a href="{% url "silk:requests" %}">
        <div class="menu-item-outer">
            <div class="menu-item-inner">Requests</div>
        </div>
    </a>
</div>
<div class="menu-item selectable-menu-item {% navactive request 'silk:profiling' %}">
    <a href="{% url "silk:profiling" %}">
        <div class="menu-item-outer">
            <div class="menu-item-inner">Profiling</div>
        </div>
    </a>
</div>
<div class="menu-item selectable-menu-item {% navactive request 'silk:cleardb' %}">
    <a href="{% url "silk:cleardb" %}">
        <div class="menu-item-outer">
            <div class="menu-item-inner">Clear DB</div>
        </div>
    </a>
</div>